import processing.serial.*;
import ddf.minim.*;

Serial serial;
Minim minim;
AudioPlayer bgm1;
AudioPlayer bgm2;
AudioPlayer bgm3;
int r, count, state;

void setup()
{
  size(1600, 900);
  frameRate(30);
  
  serial = new Serial(this, "COM1", 9600);
  
  minim = new Minim(this);
  bgm1 = minim.loadFile("bgm1.mp3");
  bgm2 = minim.loadFile("bgm2.mp3");
  bgm3 = minim.loadFile("bgm3.mp3");
  
  count = 0;
  state = 0;
}

void draw()
{ 
  if (state == 0)
  {
    background(255, 255, 255);
    fill(0, 0, 255);
    textSize(144);
    textAlign(CENTER);
    text(count, width / 2, height / 2);
    
    bgm1.loop();
    state = 1;
  }
  else if (state == 1)
  {
    if (serial.available() >= 1)
    {
      r = serial.read();
      count++;
      
      background(255, 255, 255);
      fill(0, 0, 255);
      textSize(144);
      textAlign(CENTER);
      text(count, width / 2, height / 2);
      
      if (count >= 10)
      {
        bgm1.pause();
        state = 2;
      }
    }
  }
  else if (state == 2)
  {
    bgm2.loop();
    state = 3;
  }
  else if (state == 3)
  {
    if (serial.available() >= 1)
    {
      r = serial.read();
      count++;
      
      background(255, 255, 255);
      fill(0, 0, 255);
      textSize(144);
      textAlign(CENTER);
      text(count, width / 2, height / 2);
      
      if (count >= 20)
      {
        bgm2.pause();
        state = 4;
      }
    }
  }
  else if (state == 4)
  {
    background(255, 255, 255);
    fill(0, 0, 255);
    textSize(144);
    textAlign(CENTER);
    text("Congratulations!", width / 2, height / 2);
    
    bgm3.play();
    state = 5;
  }
}

void stop()
{
  bgm1.close();
  bgm2.close();
  bgm3.close();
  minim.stop();
  super.stop();
}
